function [fu,fv,u,v] = evaluateDirichlet(gDu,gDv,fu,fv)
% Copyright (C)  Long Chen. See COPYRIGHT.txt for details.

N = size(fu,1);
h = 1/N;
%% u
u = zeros(N,N+1);
for i = 1:N
    y = 1-(i-1)*h-0.5*h;
    x = 0; % left
    u(i,1) = gDu(x,y);
    x = 1; % right
    u(i,N+1) = gDu(x,y);
end
% modify rhs
for j = 1:N+1
    x = (j-1)*h;
    y = 1; % top
    fu(1,j) = fu(1,j) + 2*gDu(x,y)/h^2;
    y = 0; % bottom
    fu(N,j) = fu(N,j) + 2*gDu(x,y)/h^2; 
end
%% v
v = zeros(N+1,N);
for j = 1:N
    x = (j-1)*h+0.5*h;
    y = 1; % top
    v(1,j) = gDv(x,y);
    y = 0; % bottom
    v(N+1,j) = gDv(x,y);
end
% modify rhs
for i = 1:N+1
    x = 0; % left
    y = 1-(i-1)*h;
    fv(i,1) = fv(i,1) + 2*gDv(x,y)/h^2;
    x = 1; % right
    fv(i,N) = fv(i,N) + 2*gDv(x,y)/h^2;
end