function [u,v,p] = evaluateuvp(funcu,funcv,funcp,N)

% Copyright (C)  Long Chen. See COPYRIGHT.txt for details.

h = 1/N;
% force
u = zeros(N,N+1);
v = zeros(N+1,N);
p = zeros(N,N);
for j = 1:N+1
    for i = 1:N
        x = (j-1)*h;
        y = 1-(i-1)*h-0.5*h;
        u(i,j) = funcu(x,y);
    end
end
for j = 1:N
    for i = 1:N+1
        x = (j-1)*h+0.5*h;
        y = 1-(i-1)*h;
        v(i,j) = funcv(x,y);
    end
end
for i = 1:N
    for j = 1:N
        x = (j-1)*h+0.5*h;
        y = 1-(i-1)*h-0.5*h;
        p(i,j) = funcp(x,y); 
    end
end