function [uf,vf,pf] = prolongation(u,v,p)
% Copyright (C)  Long Chen. See COPYRIGHT.txt for details.

N = size(p,1);
pf = zeros(2*N,2*N);
uf = zeros(2*N,2*N+1);
vf = zeros(2*N+1,2*N);

for i = 1:N
    for j = 1:N
        pf(2*i-1:2*i,2*j-1:2*j) = p(i,j);
    end
end

% first update variable in the same vertical line with coarse one
for i = 1:N
    for j = 2:N
        if i == 1
            utop = -u(i,j);
        else
            utop = u(i-1,j);
        end
        if i == N
            ubottom = -u(i,j);
        else
            ubottom = u(i+1,j);
        end
        uf(2*i,2*j-1) = 0.75*u(i,j) + 0.25*ubottom;
        uf(2*i-1,2*j-1) = 0.75*u(i,j) + 0.25*utop;
    end
end

for i = 1:2*N
    for j = 2:2:2*N
        uf(i,j) = 0.5*uf(i,j-1) + 0.5*uf(i,j+1);
    end
end

% v
for j = 1:N
    for i = 2:N
        if j==1
            vleft = -v(i,j);
        else
            vleft = v(i,j-1);
        end
        if j == N
            vright = -v(i,j);
        else
            vright = v(i,j+1);
        end
        vf(2*i-1,2*j) = 0.75*v(i,j) + 0.25*vright;
        vf(2*i-1,2*j-1) = 0.75*v(i,j) + 0.25*vleft;
    end
end
% 
for j = 1:2*N
    for i = 2:2:2*N
        vf(i,j) = 0.5*vf(i-1,j) + 0.5*vf(i+1,j);
    end
end
    