function [u,v,p] = restriction(uf,vf,pf)

% Copyright (C)  Long Chen. See COPYRIGHT.txt for details.

N = size(pf,1)/2;
p = zeros(N,N);
u = zeros(N,N+1);
v = zeros(N+1,N);

for i = 1:N
    for j = 1:N
        p(i,j) = 0.25*(pf(2*i-1,2*j-1) + pf(2*i-1,2*j) ...
                      + pf(2*i,2*j-1) + pf(2*i,2*j));
    end
end

% first update variable in the same vertical line with coarse one
for i = 1:N
    for j = 2:N
        u(i,j) = 0.125*(uf(2*i-1,2*j-2) + 2*uf(2*i-1,2*j-1) + uf(2*i-1,2*j)...
                      + uf(2*i,  2*j-2) + 2*uf(2*i,2*j-1) +   uf(2*i,2*j));
    end
end

% v
for j = 1:N
    for i = 2:N
        v(i,j) = 0.125*(vf(2*i-2,2*j-1) +   vf(2*i-2,2*j) ...
                    + 2*vf(2*i-1,2*j-1) + 2*vf(2*i-1,2*j)...
                      + vf(2*i,  2*j-1) +   vf(2*i,  2*j));        
    end
end    