pde = Stokesdata1;
smoothingstep = 1;
e = zeros(7,1); h = zeros(7,1);
for level = 4:7    
    [u,v,p] = StokesVcycle(level,smoothingstep,pde);
    [exactu,exactv,exactp] = evaluateuvp(pde.u,pde.v,pde.p,2^level);
    e(level) = max(max(max(abs(u - exactu))),max(max(abs(v - exactv))));
    h(level) = 2^(-level);
    fprintf('N = %2.0u, approximation err = %12.8g \n', 2^level, e(level));
end
e = e(e>0); h = h(h>0);
figure; 
showrate2(h.^2.*log(1./h),e,1,'b-*','h^2|log(h)|',...
          h.^2,e,1,'r-*','h^2')
title('Rate of Convergence')